// Realistic V1 [MOD GSC]
// Created By Astren
// LICENCE GNU - KRONIKER.FR

#include maps\mp\_utility;
#include common_scripts\utility;
#include maps\mp\zombies\_zm;
#include maps\mp\zombies\_zm_perks;
#include maps\mp\zombies\_zm_utility;
#include maps\mp\gametypes_zm\_hud_util;
#include maps\mp\gametypes_zm\_hud_message;


init() {
	level thread onPlayerConnect();
	replaceFunc(::give_perk, ::give_perk_override);
	level.perk_purchase_limit = 9;
	SetDvar( "ui_errorTitle", "^1RealisticV4");
	SetDvar( "ui_errorMessage", "^5Thanks For Playing ! ^2Website ^7: ^1kroniker.fr ^7! ^2Creator ^7: ^1ASTREN");
}

onPlayerConnect() {
	for(;;) {
		level waittill("connected", player);
		player iprintln("Joueur" + player + "connecté");
		player iprintln("^5Realistic V1 [^1MOD^5] ^7: ^2Started");
		player iprintln("^5Perks ^7: ^2Unlimited");
		player iprintln("^5Healt Bar ^7: ^2Activate");
		player iprintln("^5Zombie Counter ^7: ^2Activate");
		player thread onPlayerSpawned();
		player thread SetClientDvars();
		level.perk_purchase_limit = 9;
	}
}

SetClientDvars() {
	for(;;) {
	SetDvar("sv_cheats", 1);
    SetDvar("r_fog", 0);
    SetDvar("r_skyTransition", 1);
	SetDvar("cg_fov", 90);
    SetDvar("r_lightTweakSunColor", "1 1 1");
    SetDvar("cg_useColorControl", 1);
    SetDvar("cg_colorScale", "0.5 0.5 0.9");
	SetDvar("cg_colorScale", "0.5 0.5 0.9");
	SetDvar( "ui_errorTitle", "^1RealisticV4");
	SetDvar( "ui_errorMessage", "^5Thanks For Playing ! ^2Website ^7: ^1kroniker.fr ^7! ^2Creator ^7: ^1ASTREN");
	wait 0.5;
	}
}

onPlayerSpawned() {
	level endon("end_game");
	self endon("disconnect");
	self waittill("spawned_player");
    self thread ZmCtn();
	self thread HealthBar();
}

HealthBar() {
	level endon("end_game");
	self endon("disconnect");
	flag_wait("initial_blackscreen_passed");

	HealthBar = self createprimaryprogressbar();

	if (level.script == "zm_buried") {
		HealthBar setpoint(undefined, "BOTTOM", 0, -5);
	} else if (level.script == "zm_tomb") {
		HealthBar setpoint(undefined, "BOTTOM", 0, -5);
	} else {
		HealthBar setpoint(undefined, "BOTTOM", 0, -5);
	}

	HealthBar.hidewheninmenu = 1;
	HealthBar.bar.hidewheninmenu = 1;
	HealthBar.barframe.hidewheninmenu = 1;

	while (1) {
		if (isDefined(self.e_afterlife_corpse)) {
			if (HealthBar.alpha != 0) {
				HealthBar.alpha = 0;
				HealthBar.bar.alpha = 0;
				HealthBar.barframe.alpha = 0;
			}
			wait 0.05;
			continue;
		}

		if (HealthBar.alpha != 1) {
			HealthBar.alpha = 1;
			HealthBar.bar.alpha = 1;
			HealthBar.barframe.alpha = 1;
		}

		HealthBar updatebar(self.health / self.maxhealth);
		wait 0.05;
	}
}

ZmCtn() {
    level endon( "game_ended" );
    self endon("disconnect");
    flag_wait( "initial_blackscreen_passed" );
    self.ZmbCounter = createfontstring( "Objective", 1.7 );
    self.ZmbCounter setpoint( "CENTER", "CENTER", 0, 180 );
    self.ZmbCounter.alpha = 1;
    self.ZmbCounter.hidewheninmenu = 1;
    self.ZmbCounter.hidewhendead = 1;
    self.ZmbCounter.label = &"^5Zombies : ^1";
    for(;;) {
        if(isdefined(self.afterlife) && self.afterlife) {
            self.ZmbCounter.alpha = 0.2;
        } else {
            self.ZmbCounter.alpha = 1;
        }
        self.ZmbCounter setvalue( level.zombie_total + get_current_zombie_count() );
        wait 0.05;
    }
}

perkHUD(perk) {
	level endon("end_game");
	self endon( "disconnect" );


    switch( perk ) {
    	case "specialty_armorvest":
        	shader = "specialty_juggernaut_zombies";
        	break;
    	case "specialty_quickrevive":
        	shader = "specialty_quickrevive_zombies";
        	break;
    	case "specialty_fastreload":
        	shader = "specialty_fastreload_zombies";
        	break;
    	case "specialty_rof":
        	shader = "specialty_doubletap_zombies";
        	break;  
    	case "specialty_longersprint":
        	shader = "specialty_marathon_zombies";
        	break; 
    	case "specialty_flakjacket":
        	shader = "specialty_divetonuke_zombies";
        	break;  
    	case "specialty_deadshot":
        	shader = "specialty_ads_zombies";
        	break;
    	case "specialty_additionalprimaryweapon":
        	shader = "specialty_additionalprimaryweapon_zombies";
        	break; 
		case "specialty_scavenger": 
			shader = "specialty_tombstone_zombies";
        	break; 
    	case "specialty_finalstand":
			shader = "specialty_chugabud_zombies";
        	break; 
    	case "specialty_nomotionsensor":
			shader = "specialty_vulture_zombies";
        	break; 
    	case "specialty_grenadepulldeath":
			shader = "specialty_electric_cherry_zombie";
        	break; 
    	default:
        	shader = "";
        	break;
    }


	perk_hud = newClientHudElem(self);
	perk_hud.alignx = "center";
	perk_hud.aligny = "middle";
	perk_hud.horzalign = "user_center";
	perk_hud.vertalign = "user_top";
	perk_hud.x += 0;
	perk_hud.y += 120;
	perk_hud.fontscale = 2;
	perk_hud.alpha = 1;
	perk_hud.color = ( 1, 1, 1 );
	perk_hud.hidewheninmenu = 1;
	perk_hud.foreground = 1;
	perk_hud setShader(shader, 128, 128);
	
	
	perk_hud moveOvertime( 0.25 );
    perk_hud fadeovertime( 0.25 );
    perk_hud scaleovertime( 0.25, 64, 64);
    perk_hud.alpha = 1;
    perk_hud.setscale = 2;
    wait 3.25;
    perk_hud moveOvertime( 1 );
    perk_hud fadeovertime( 1 );
    perk_hud.alpha = 0;
    perk_hud.setscale = 5;
    perk_hud scaleovertime( 1, 128, 128);
    wait 1;
    perk_hud notify( "death" );

    if ( isdefined( perk_hud ) ) {
		perk_hud destroy();
	}
}
        


getPerkShader(perk) {
	if(perk == "specialty_armorvest") {
		return "Juggernog";
	}
		
	if(perk == "specialty_rof") {
		return "Double Tap";
	}
		
	if(perk == "specialty_longersprint") {
		return "Stamin-Up";
	}
		
	if(perk == "specialty_fastreload") {
		return "Speed Cola";
	}
		
	if(perk == "specialty_additionalprimaryweapon") {
		return "Mule Kick";
	}
		
	if(perk == "specialty_quickrevive") {
		return "Quick Revive";
	}
		
	if(perk == "specialty_finalstand") {
		return "Who's Who";
	}

	if(perk == "specialty_grenadepulldeath") {
		return "Electric Cherry";
	}

	if(perk == "specialty_flakjacket") {
		return "PHD Flopper";
	} 

	if(perk == "specialty_deadshot") {
		return "Deadshot Daiquiri";
	}

	if(perk == "specialty_scavenger") {
		return "Tombstone";
	}

	if(perk == "specialty_nomotionsensor") {
		return "Vulture Aid";
	}

}

give_perk_override( perk, bought ) {
    self setperk( perk );
    self.num_perks++;

    if ( isdefined( bought ) && bought ) {
        self maps\mp\zombies\_zm_audio::playerexert( "burp" );

        if ( isdefined( level.remove_perk_vo_delay ) && level.remove_perk_vo_delay ){
			self maps\mp\zombies\_zm_audio::perk_vox( perk );
		} else {
			self delay_thread( 1.5, maps\mp\zombies\_zm_audio::perk_vox, perk );
		}

        self setblur( 4, 0.1 );
        wait 0.1;
        self setblur( 0, 0.1 );
        self notify( "perk_bought", perk );
    }

    self perk_set_max_health_if_jugg( perk, 1, 0 );

    if ( !( isdefined( level.disable_deadshot_clientfield ) && level.disable_deadshot_clientfield ) ) {
        if ( perk == "specialty_deadshot" ) {
			self setclientfieldtoplayer( "deadshot_perk", 1 );
		} else if ( perk == "specialty_deadshot_upgrade" ) {
			self setclientfieldtoplayer( "deadshot_perk", 1 );
		}
    }

    if ( perk == "specialty_scavenger" ) {
		self.hasperkspecialtytombstone = 1;
	}

    players = get_players();

    if ( use_solo_revive() && perk == "specialty_quickrevive" ) {
        self.lives = 1;

        if ( !isdefined( level.solo_lives_given ) ) {
			level.solo_lives_given = 0;
		}

        if ( isdefined( level.solo_game_free_player_quickrevive ) ) {
			level.solo_game_free_player_quickrevive = undefined;
		} else {
			level.solo_lives_given++;
		}
            

        if ( level.solo_lives_given >= 3 ) {
			flag_set( "solo_revive" );
		}
        
        self thread solo_revive_buy_trigger_move( perk );
    }

    if ( perk == "specialty_finalstand" ) {
        self.lives = 1;
        self.hasperkspecialtychugabud = 1;
        self notify( "perk_chugabud_activated" );
    }

    if ( isdefined( level._custom_perks[perk] ) && isdefined( level._custom_perks[perk].player_thread_give ) ) {
		self thread [[ level._custom_perks[perk].player_thread_give ]]();
	}
        

    self set_perk_clientfield( perk, 1 );
    maps\mp\_demo::bookmark( "zm_player_perk", gettime(), self );
    self maps\mp\zombies\_zm_stats::increment_client_stat( "perks_drank" );
    self maps\mp\zombies\_zm_stats::increment_client_stat( perk + "_drank" );
    self maps\mp\zombies\_zm_stats::increment_player_stat( perk + "_drank" );
    self maps\mp\zombies\_zm_stats::increment_player_stat( "perks_drank" );

    if ( !isdefined( self.perk_history ) ) {
		self.perk_history = [];
	}

    self.perk_history = add_to_array( self.perk_history, perk, 0 );

    if ( !isdefined( self.perks_active ) ) {
		self.perks_active = [];
	}

    self.perks_active[self.perks_active.size] = perk;
    self notify( "perk_acquired" );
    self thread perk_think( perk );
    self perkHUD(perk);
}